// Point3D.cpp : implementation file
//

#include "stdafx.h"
#include "SimpleCObject.h"
#include "Point3D.h"
#include <iostream>

// CPoint3D
IMPLEMENT_SERIAL(CPoint3D, CObject, 1)

CPoint3D::CPoint3D()
{
	m_nX = 0;
	m_nY = 0;
	m_nZ = 0;
}

CPoint3D::CPoint3D(int x, int y, int z)
{
	m_nX = x;
	m_nY = y;
	m_nZ = z;
}

CPoint3D::CPoint3D(const CPoint3D& other)
{
	m_nX = other.m_nX;
	m_nY = other.m_nY;
	m_nZ = other.m_nZ;
}

CPoint3D::CPoint3D(const int * other)
{
	m_nX = other[0];
	m_nY = other[1];
	m_nZ = other[2];
}

CPoint3D::~CPoint3D()
{
}


// CPoint3D member functions
void CPoint3D::SetPosition(int x, int y, int z)
{
	m_nX = x;
	m_nY = y;
	m_nZ = z;
}

void CPoint3D::Move(int x, int y, int z)
{
	m_nX += x;
	m_nY += y;
	m_nZ += z;
}

void CPoint3D::Show()
{
	std::cout << "X=" << m_nX << " Y=" << m_nY << " Z=" << m_nZ << std::endl;
}

CPoint3D& CPoint3D::operator++()
{
	SetPosition(++m_nX, ++m_nY, ++m_nZ);
	return *this;
}

CPoint3D CPoint3D::operator+(const CPoint3D &other)
{
    CPoint3D vResult(0, 0, 0);

    vResult.m_nX = m_nX + other.m_nX;
    vResult.m_nY = m_nY + other.m_nY;
    vResult.m_nZ = m_nY + other.m_nZ;

    return vResult;
}

// This function is required for built-in STL list functions like sort
int CPoint3D::operator<(const CPoint3D &rhs) const
{
   if( this->m_nX == rhs.m_nX && this->m_nY == rhs.m_nY && this->m_nZ < rhs.m_nZ) return 1;
   if( this->m_nX == rhs.m_nX && this->m_nY < rhs.m_nY) return 1;
   if( this->m_nX < rhs.m_nX ) return 1;
   return 0;
}

// This function is required for built-in STL list functions like find
int CPoint3D::operator==(const CPoint3D &rhs) const
{
   if( this->m_nX == rhs.m_nX && this->m_nY == rhs.m_nY && this->m_nZ == rhs.m_nZ) return 1;
   return 0;
}

void CPoint3D::Serialize(CArchive& ar)
{
	CObject::Serialize(ar);
	if(ar.IsStoring())
		ar << m_nX << m_nY << m_nZ;
	else
		ar >> m_nX >> m_nY >> m_nZ;
}

#ifdef _DEBUG
void CPoint3D::AssertValid() const
{
	CObject::AssertValid();
	ASSERT(this != NULL);	//  this pointer NULL ƴ 
}
#endif
